package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10060FarmActivateBean;
import cn.net.cpzslibs.prot.handset.bean.ResMsgBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot10060FarmActivate extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10060 = 10060;
	private Gson gson;
	private ResMsgBean resMsgBean;
	
	public Prot10060FarmActivate() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public ResMsgBean getResMsg(){
		return this.resMsgBean;
	}
	
	public void dealActiveList(SocketCreate create, Prot10060FarmActivateBean labelBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), labelBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10060FarmActivateBean labelBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10060, "开始请求产品列表激活协议");
				sendProt(dos, labelBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10060, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10060, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resMsgBean = gson.fromJson(jsonData, ResMsgBean.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10060FarmActivateBean labelBean) throws IOException {
		String bodyContent = gson.toJson(labelBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10060, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
